import java.lang.reflect.*;
import java.util.*;

final public aspect SizeOf pertypewithin(*) {
    static private Map cache = Collections.synchronizedMap(new HashMap());
    private int size = -1;

    // is this the right way to do this?
    after() : staticinitialization(*) {	
	size = computeSize(thisJoinPointStaticPart.getSignature().getDeclaringType(),null);
    }
    
    public static int get(Object o) { 
	Class c = o.getClass();
	
	if(SizeOf.hasAspect(c)) {
	    info("(static)\t");
	    SizeOf a = SizeOf.aspectOf(c);
	    return a.size;
	} else {
	    Integer r = (Integer) cache.get(c);
	    if(r != null) { info("(from cache)\t"); return r; }
	    else {
		info("(now cached)\t");
		int x = computeSize(c,o);
		cache.put(c,x);
		return x;
	    } 
	} 
    }

    static boolean debug = false;
    static void debug(boolean f) { debug = f; }
    static public void info(String m) {
	if(debug) { System.out.print(m); }
    }
    
    static public int computeSize(Class c, Object o) {
	// this function aims to be close to C's sizeof()			
	if(c.isArray()) { 
	    int len = Array.getLength(o); // get array's length
	    return primitiveSize(c.getComponentType()) * len;
	} else {			
	    int r = 0;
	    Field f[] = c.getDeclaredFields();
	    for(int i=0;i!=f.length;++i) {
		Class ft = f[i].getType ();				
		r += primitiveSize(f[i].getType());
	    }
	    Class s = c.getSuperclass();
	    if(s != null) { r += computeSize(s,o); }
	    return r;
	}			
    }

    static private int primitiveSize(Class pt) {
	if (pt == int.class) return 4;
	else if (pt == float.class) return 4;
	else if (pt == boolean.class) return 1;
	else if (pt == long.class) return 8;
	else if (pt == char.class) return 2;
	else if (pt == short.class) return 2;
	else if (pt == byte.class) return 1;
	else if (pt == double.class) return 8;
	else { return 4; }	            
    }
}
