public class Test {
    private int aField=1;

    final static int N = 100000;

    public static void main(String args[]) {
	SizeOf.debug(true);
	System.out.println("SizeOf(new Test()) = " + SizeOf.get(new Test()));
	System.out.println("SizeOf(new String(\"HELLO\")) = " + SizeOf.get(new String("HELLO")));
	System.out.println("SizeOf(new String[1000]) = " + SizeOf.get(new String[1000]));
	System.out.println("SizeOf(new byte[10000]) = " + SizeOf.get(new byte[10000]));
	System.out.println("SizeOf(new Test()) = " + SizeOf.get(new Test()));
	System.out.println("SizeOf(new String(\"HELLO\")) = " + SizeOf.get(new String("HELLO")));
	System.out.println("SizeOf(new String[1000]) = " + SizeOf.get(new String[1000]));
	System.out.println("SizeOf(new byte[10000]) = " + SizeOf.get(new byte[10000]));

	SizeOf.debug(false);
	System.out.println("\n=== PERFORMANCE TESTS ===");
	System.out.println("\nN = " + N);
	
	for(int i=0;i!=5;++i) {
	    System.out.println("==== RUN #" + i + " ====");
	    System.out.println("Average cost for static lookup : " + staticTest() + "ms");
	    System.out.println("Average cost for cache lookup : " + cacheTest() + "ms");
	}
    }

    public static double staticTest() {
	int r = 0;
	Test t = new Test();
	long t1 = System.currentTimeMillis();
	for(int i=0;i!=N;++i) {
	    r += SizeOf.get(t);
	}
	long t2 = System.currentTimeMillis();	
	return ((double) (t2-t1)) / N;
    }

    public static double cacheTest() {
	int r = 0;
	String s = new String();
	long t1 = System.currentTimeMillis();
	for(int i=0;i!=N;++i) {
	    r += SizeOf.get(s);
	}
	long t2 = System.currentTimeMillis();	
	return ((double) (t2-t1)) / N;
    }
}
